// "Chips Tester Device"
//       Main file
//    (C) S.A., 1997
//---------------------------------------------------------------------
#include <all.h>
#include "wintxt.h"
#include "chiptest.h"
//============================================================
int werror(char *msg)    // 1 - yes, 0 - no
{
Win *a = new Win(15, 7, 50, 5, 0, WERR);
a->Head(" Error ", RIGHT);
Key *ok = new Key(a, 5, 3, "Ok", 10, CENTER, '\0', 0, 0, 0);
Key *cn = new Key(a, 25, 3, "Cancel", 10, CENTER, '\0', 0, 0, 0);
a->set(ok); a->set(cn);
a->on(); ok->on(); cn->on();
printq(a->wxb() + 1, a->wyb() + 1, msg);
sound(580); delay(50); nosound();
int r = a->input(0);
delete a;
if (r == 0)
 return 1;
return 0;
}
//============================================================
void warning(char *msg)
{
Win *a = new Win(15, 7, 50, 5, 0, WERR);
a->Head(" Error ", RIGHT);
Key *ok = new Key(a, 20, 3, "Ok", 10, CENTER, '\0', 0, 0, 0);
a->set(ok);
a->on(); ok->on();
printq(a->wxb() + 1, a->wyb() + 1, msg);
sound(480); delay(50); nosound();
a->input(0);
delete a;
}
//============================================================
struct header        //  䠩 p奬
{
char id[64];
char setrem[64];      // 孮 + p p奬
int pins;             // ⠪⮢
char func[64];       // 㭪
char rem[64];
long parts;          // -  ⮢ -     !
word reserved[128];
};
//------------------------------------------------------------
struct part          // pp . 
{
word send;
word receive;        // - 0xFFFF -  pp p頥
};
//------------------------------------------------------------
char *ID = "Chip Tester File. (C) Artyom Pro, 1997";
//============================================================
const MAXPARTS = 9000;
char name[128];
header head;
part parts[MAXPARTS];
//---------------------------------------------------------------------
int loading(void)
{
_fmode = O_BINARY;
if (strlen(name) == 0)
 {
 warning("No file name!");
 return 0;
 }
int h = open(name, O_RDONLY);
if (h == -1)
 {
 warning("Error opening file!");
 return 0;
 }
word r1 = read(h, &head, sizeof(header));
word r2 = read(h, parts, sizeof(part) * head.parts);
close(h);
if (r1 != sizeof(header) || r2 != sizeof(part) * head.parts)
 {
 warning("Incorrect file length !");
 return 0;
 }
return 1;
}
//---------------------------------------------------------------------
int testms(int a)
{
Win *c = new Win(15, 9, 50, 2, 0, WHLP);
c->Head(" Testing chip ... Don't interrupt ... ", LEFT);
c->on();
tester_on();
static char bt[128];
static char btt[64];
for (long t = 0; t < head.parts; t ++)
 {
 word re = msoi(parts[t].send);
 if (parts[t].receive == 0xFFFF)
  continue;
 if (re != parts[t].receive)
  {
  tester_off();
  strcpy(bt, ": ");
  strcat(bt, itoa(t + 1, btt, 10));
  strcat(bt, "  ᥣ: ");
  strcat(bt, itoa(head.parts, btt, 10));
  strcat(bt, "  !!!  !!!");
  printq(c->wxb() + 1, c->wyb(), bt);
  Win *b = new Win(10, 5, 50, 5, 0, WERR);
  b->Head(" p⠫  p! ", LEFT);
  b->on();
  Key *ok = new Key(b, 2, 3, "Ok", 10, CENTER, '\0', 0, 0, 0);
  b->set(ok);
  ok->on();
  strcpy(bt, "  蠣 p: ");
  strcat(bt, itoa(t + 1, btt, 10));
  printq(b->wxb() + 1, b->wyb(), bt);
  sound(400); delay(200);
  nosound();
  b->input();
  delete b;
  delete c;
  return 0;
  }
 if (t % 256 == 0)
  {
  strcpy(bt, ": ");
  strcat(bt, itoa(t + 1, btt, 10));
  strcat(bt, "  ᥣ: ");
  strcat(bt, itoa(head.parts, btt, 10));
  printq(c->wxb() + 1, c->wyb(), bt);
  }
 }
tester_off();
strcpy(bt, ": ");
strcat(bt, itoa(t, btt, 10));
strcat(bt, "  ᥣ: ");
strcat(bt, itoa(head.parts, btt, 10));
strcat(bt, " - Okay!");
printq(c->wxb() + 1, c->wyb(), bt);
Win *b = new Win(12, 11, 30, 3, 0, WSTAND);
b->Head(" p奬 p. ", LEFT);
b->on();
Key *ok = new Key(b, 2, 1, "Ok", 10, CENTER, '\0', 0, 0, 0);
b->set(ok);
ok->on();
sound(600); delay(100); sound(800); delay(100);
nosound();
b->input();
delete b;
delete c;
return 1;
}
//---------------------------------------------------------------------
void worked(void)
{
static char bak[128];
Win *scr = new Win(4, 6, 70, 12, 0, WSTAND);
scr->Head(" Chip info ", CENTER);
static char buf[64];
scr->on();
strcpy(bak, "File ID: "); strcat(bak, head.id);
printq(scr->wxb() + 1, scr->wyb() + 1, bak);
strcpy(bak, "Chip tech/series: "); strcat(bak, head.setrem);
printq(scr->wxb() + 1, scr->wyb() + 2, bak);
strcpy(bak, "Chip function: "); strcat(bak, head.func);
printq(scr->wxb() + 1, scr->wyb() + 3, bak);
strcpy(bak, "Remark: "); strcat(bak, head.rem);
printq(scr->wxb() + 1, scr->wyb() + 4, bak);
strcpy(bak, "Amount of pins: "); strcat(bak, itoa(head.pins, buf, 10));
printq(scr->wxb() + 1, scr->wyb() + 5, bak);
Key *ok = new Key(scr, 14, 7, "Test (Set chip in panel!)", 30, CENTER, '\0', 0, 0, testms);
Key *no = new Key(scr, 14, 9, "Cancel", 30, CENTER, '\0', 0, 0, 0);
scr->set(ok); scr->set(no);
ok->on(); no->on();
scr->input(0);
delete scr;
return;
}
//---------------------------------------------------------------------
int named(void)
{
Win *a = new Win(5, 8, 60, 6, 0, WSTAND2);
a->Head(" File name ", LEFT);
Field *f1 = new Field(a, 4, 2, 50, " 䠩 / ⨯ p奬:", name, 0, 0);
Key *ok = new Key(a, 20, 4, "Ok", 10, CENTER, '\0', 0, 0, 0);
a->set(f1); a->set(ok);
a->on(); f1->on(); ok->on();
int r = a->input();
delete a;
if (r == CLOSED)
 return 0;
return 1;
}
//---------------------------------------------------------------------
int hlop(void)
{
if (! named())
 return 0;
if (! loading())
 return 1;
worked();
return 1;
}
//---------------------------------------------------------------------
void work(void)
{
while (hlop())
 ;
}
//---------------------------------------------------------------------
int main(void)
{
name[0] = 0;
Install_TXT_Window();
DownMessage("Detecting hardware tester ...", LEFT);
if (testerinstall())
 DownMessage("The Chip Tester hard & soft  ", LEFT);
else
 {
 DownMessage("       WARNING!!! TESTER HARDWARE NOT FOUND/CONNECTED/POWERED!!!", LEFT);
 if (! werror("Tester not found! Proceed?"))
  {
  Delete_TXT_Window("Bye !!!");
  return 0;
  }
 }
UpMessage("(C) Artyom Programmer, 1997", RIGHT);
work();
Delete_TXT_Window("Bye !!!");
return 0;
}
